Bug 240494 - x11-toolkits/qt5-declarative: fails to install with debugging support
Summary: x11-toolkits/qt5-declarative: fails to install with debugging support
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: --- Affects Only Me
Assignee: freebsd-kde (Team)
URL:
Keywords: needs-patch
Depends on:
Blocks:
 
Reported: 2019-09-11 09:12 UTC by Jan Beich
Modified: 2021-05-04 23:24 UTC (History)
2 users (show)

See Also:
rakuco: maintainer-feedback+


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jan Beich freebsd_committer 2019-09-11 09:12:16 UTC
$ make install WITH_DEBUG=
[...]
===>  Installing for qt5-declarative-5.12.2_1
===>  Checking if qt5-declarative is already installed
===>   Registering installation for qt5-declarative-5.12.2_1
pkg-static: Unable to access file /wrkdirs/usr/ports/x11-toolkits/qt5-declarative/work/stage/usr/local/lib/qt5/libQt5Qml.so.5.12.2.debug:No such file or directory
pkg-static: Unable to access file /wrkdirs/usr/ports/x11-toolkits/qt5-declarative/work/stage/usr/local/lib/qt5/libQt5Quick.so.5.12.2.debug:No such file or directory
pkg-static: Unable to access file /wrkdirs/usr/ports/x11-toolkits/qt5-declarative/work/stage/usr/local/lib/qt5/libQt5QuickParticles.so.5.12.2.debug:No such file or directory
pkg-static: Unable to access file /wrkdirs/usr/ports/x11-toolkits/qt5-declarative/work/stage/usr/local/lib/qt5/libQt5QuickShapes.so.5.12.2.debug:No such file or directory
[...]

Full build log: https://reviews.freebsd.org/P307
Comment 1 Raphael Kubo da Costa freebsd_committer 2019-10-12 23:24:02 UTC
This seems to affect all ports that use qmake as a build system (i.e. not the ports that use CMake and have USES=qmake).

Even though qmake is invoked with CONFIG+=debug and QT_CONFIG+='debug separate_debug_info', /usr/local/lib/qt5/mkspecs/qconfig.pri has "separate_debug_info" in QT.global.disabled_features, so the qtConfig(separate_debug_info) check in /usr/local/lib/qt5/mkspecs/qt_common.prf will fail.

Adding "separate_debug_info" to 

    QMAKE_ARGS+=            CONFIG+="debug separate_debug_info" \

in Uses/qmake.mk, but it might break pkg-plist in ports that don't have separate .debug entries for their libraries.
Comment 2 commit-hook freebsd_committer 2021-05-04 23:11:26 UTC
A commit in branch main references this bug:

URL: https://cgit.FreeBSD.org/ports/commit/?id=5739a98d1d68c09ff0dbb2c4ab29f02a82d16610

commit 5739a98d1d68c09ff0dbb2c4ab29f02a82d16610
Author:     Adriaan de Groot <adridg@FreeBSD.org>
AuthorDate: 2021-05-03 20:47:44 +0000
Commit:     Adriaan de Groot <adridg@FreeBSD.org>
CommitDate: 2021-05-04 23:10:26 +0000

    Uses/qmake.mk: fix build WITH_DEBUG

    When setting WITH_DEBUG, separate debuginfo was **not** created,
    although the plists for most Qt5 ports list separate debuginfo.
    Take a suggestion from rakuco@ and run with it. I rebuilt all the
    ports with USES=qmake and none had issues with separate debuginfo.

    No general PORTREVISION bump because the packages in most cases
    do not change with default options, and WITH_DEBUG would have
    failed to package anyway.

    PR:             240494
    Reported by:    jbeich

 Mk/Uses/qmake.mk | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)
Comment 3 Adriaan de Groot freebsd_committer 2021-05-04 23:24:40 UTC
Raphael's suggestion was straightforward, and building a few hundred ports that use qmake this way gave me no errors with plist that weren't strip(1)'s fault, so I've pushed it (so now WITH_DEBUG builds **do** work, where before they didn't)